Package: rixmp
Type: Package
Title: R Interface to the IX Modeling Platform
Version: 3.2.0.9000
Authors@R: c(
    person("Adriano", "Vinca", email = "vinca@iiasa.ac.at",
           role = c("aut", "cre")),
    person(c("Paul", "Natsuo"), "Kishimoto", email = "kishimot@iiasa.ac.at",
           role = "ctb"),
    person("Matthew", "Gidden", role = "aut"))
Description: The ix modeling platform (ixmp) is a data warehouse for
    high-powered scenario analysis, with interfaces to Python and R for
    efficient scientific workflows and effective data pre- and post-processing,
    and a structured database backend for version-controlled data management.
    This package allows R user to use code developed in Python and interact
    with the ix modeling platform.
Depends:
    R (>= 3.3.0),
    reticulate
Suggests:
    testthat
License: Apache License 2.0
URL: https://github.com/iiasa/ixmp
BugReports: https://github.com/iiasa/ixmp/issues
Encoding: UTF-8
RoxygenNote: 7.0.2
Collate:
    'init_rixmp.R'
    'adapt_to_ret.R'

# `ixmp`: the ix modeling platform

[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.4005665.svg)](https://doi.org/10.5281/zenodo.4005665)
[![PyPI version](https://img.shields.io/pypi/v/ixmp.svg)](https://pypi.python.org/pypi/ixmp/)
[![Anaconda version](https://img.shields.io/conda/vn/conda-forge/ixmp)](https://anaconda.org/conda-forge/ixmp)
[![Documentation build](https://readthedocs.com/projects/iiasa-energy-program-ixmp/badge/?version=master)](https://docs.messageix.org/projects/ixmp/en/master/)
[![Build status](https://github.com/iiasa/ixmp/actions/workflows/pytest.yaml/badge.svg)](https://github.com/iiasa/ixmp/actions/workflows/pytest.yaml)
[![Test coverage](https://codecov.io/gh/iiasa/ixmp/branch/master/graph/badge.svg)](https://codecov.io/gh/iiasa/ixmp)

The ix modeling platform (`ixmp`) is a data warehouse for high-powered scenario
analysis, with interfaces to Python and R for efficient scientific workflows and
effective data pre- and post-processing, and a structured database backend for
version-controlled data management.
In the name, “ix” stands for “integrated” and “cross (x) cutting”.

The [MESSAGEix modeling *framework*](https://docs.messageix.org) is built on top of the ix modeling *platform*.


This repository contains the core and application programming interfaces (API)
for the ix modeling platform (ixmp), as well as a number of tutorials and
examples for a generic model instance based on Dantzig's transport problem.

## Documentation

Complete documentation of the ixmp API is available for current and past versions at: https://docs.messageix.org/ixmp/.
This includes:

- **Installation.**
  Most users will have ixmp installed automatically as a dependency when
[installing MESSAGEix](https://docs.messageix.org/en/stable/#getting-started).
  To install ixmp from source code, or to use ixmp from R, see
[‘Installation’](https://docs.messageix.org/projects/ixmp/en/stable/install.html) or [`INSTALL.rst`](INSTALL.rst).
- **Tutorials.** Introductory tutorials are provided in both Python and R; see [‘Tutorials’](https://docs.messageix.org/projects/ixmp/en/stable/tutorials.html) or [`tutorial/README.rst`](tutorial/README.rst).
- How to **cite `ixmp` when using it in published scientific work.** See [‘User guidelines and notice’](https://docs.messageix.org/en/stable/notice.html) or [`NOTICE.rst`](NOTICE.rst).
- **Changelog and migration notes** for each new release: see [“What's New”](https://docs.messageix.org/projects/ixmp/en/stable/whatsnew.html).

Other forms of documentation:

- The online documentation is built automatically from the contents of the
[ixmp GitHub repository](https://github.com/iiasa/ixmp).
- For documentation of a specific release, e.g. `v3.2.0`, use the chooser in the bottom sidebar.
- For offline use, the documentation can be built from the source code.
See [`doc/README.rst`](doc/README.rst) for further details.
- The [MESSAGEix API documentation](https://docs.messageix.org/en/stable/api.html) links to the ixmp documentation in many places, for convenience.

## License

Copyright © 2017–2021 IIASA Energy, Climate, and Environment (ECE) program

`ixmp` is licensed under the Apache License, Version 2.0 (the "License"); you
may not use the files in this repository except in compliance with the License.
You may obtain a copy of the License in [`LICENSE`](LICENSE) or at
<https://www.apache.org/licenses/LICENSE-2.0>.

# rixmp.legacy
R package for ix modeling platform (ixmp)

The ix modeling platform (ixmp) is a data warehouse for high-powered scenario analysis, with 
interfaces to Python and R for efficient scientific workflows and effective data pre- and post-processing, 
and a structured database backend for version-controlled data management.

Can be integrated with the |MESSAGEix| Integrated Assessment model and other numerical models
http://MESSAGEix.iiasa.ac.at

References

Daniel Huppmann, Matthew Gidden, Oliver Fricko, Peter Kolp, Clara Orthofer,
  Michael Pimmer, Nikolay Kushin, Adriano Vinca, Alessio Mastrucci,
  Keywan Riahi, and Volker Krey.
  "The |MESSAGEix| Integrated Assessment Model and the ix modeling platform".
  *Environmental Modelling & Software* 112:143-156, 2019. 
  doi: [10.1016/j.envsoft.2018.11.012](https://doi.org/10.1016/j.envsoft.2018.11.012)
  electronic pre-print available at
  [pure.iiasa.ac.at/15157/](https://pure.iiasa.ac.at/15157/).

.test_mp_count <- 0

test_mp <- function () {
  # An ixmp.Platform connected to a temporary, local database.
  #
  # This function mirrors the pytest fixture of the same name, defined in
  # ixmp.testing.
  # FIXME use pytest internals to call the fixture functions directly

  # Name for the temporary platform
  url <- paste0("jdbc:hsqldb:mem:rixmp ", .test_mp_count)
  .test_mp_count <<- .test_mp_count + 1

  # launch Platform and connect to testdb (reconnect if closed)
  mp <- ixmp$Platform(backend = "jdbc", driver = "hsqldb", url = url)
  mp$open_db()

  return(mp)
}

context('Reporting')


test_that('the canning problem can be reported', {
  # Create the Scenario
  mp <- test_mp()
  scen <- ixmp$testing$make_dantzig(mp, solve = TRUE)

  # Reporter.from_scenario can handle the Dantzig problem
  rep <- ixmp$reporting$Reporter$from_scenario(scen)

  # Partial sums are available
  d_i <- rep$get('d:i')
})

context('Core')


test_that('correct Python and dependencies are used', {
  ixmp$show_versions()
})


test_that('the JVM can be started', {
  ixmp$backend$jdbc$start_jvm()
})


test_that('a local Platform can be instantiated', {
  ixmp$Platform(backend = "jdbc", driver = "hsqldb",
                url="jdbc:hsqldb:mem:rixmp test")
})


test_that('set, mapping sets and par values can be set on a Scenario', {
  mp <- test_mp()

  # Details for creating a new scenario in the ix modeling platform
  model <- 'test_model'
  scenario  <- 'standard'
  annot <- 'scenario for testing retixmp'

  # Initialize a new ixmp.Scenario
  # The parameter version='new' indicates that this is a new scenario instance
  scen <- ixmp$Scenario(mp, model, scenario, 'new', annotation = annot)
  expect_silent(scen)

  # Define the sets of locations of canning plants
  scen$init_set('i')
  i.set = c('seattle', 'san-diego')
  scen$add_set('i', i.set)
  expect_equal(as.character(scen$set('i')), i.set)

  scen$init_set('j')
  j.set = c('country', 'city')
  scen$add_set('j', j.set)
  map_ij.set = data.frame(i = i.set, j = 'city', stringsAsFactors = F)
  scen$init_set('map_ij', c('i', 'j'))
  scen$add_set('map_ij', adapt_to_ret(map_ij.set))
  a = scen$set('map_ij')
  attributes(a)$pandas.index = NULL
  expect_equal(a, map_ij.set)

  scen$commit('initialize scenario')
  scen$check_out()

  # Initialize parameter
  scen$init_par('a', c('i'))
  a.df = data.frame(i = c('seattle', 'san-diego'), value = c(350, 600),
                    unit = 'cases', stringsAsFactors = F)
  scen$add_par('a', adapt_to_ret(a.df))
  a = scen$par('a')
  attributes(a)$pandas.index = NULL

  expect_equal(a, a.df)
})


test_that('the canning problem can be solved', {
  # Create the Scenario
  mp <- test_mp()

  scen <- ixmp$testing$make_dantzig(mp, solve = TRUE)

  # Check value
  expect_equal(scen$var("z")$lvl, 153.675, tolerance = 1e-4)
})

#' Auxiliary function for conversion from R data.frame to Python
#'
#' @description
#' This function converts an R data.frame to be a valid input to
#' ixmp$Scenario$add_par() or ixmp$Scenario$add_set().
#'
#' @param set_par Dataframe corresponding to a set or a parameter to be loaded
#'   in ixmp
#'
#' @export
#' @examples
#' if (FALSE) {
#'
#' a.df <- data.frame(i = c("a", "b"), value = c(350 , 600), unit = "cases")
#' scen$add_par("a", adapt_to_ret(a.df))
#'
#' }

adapt_to_ret = function(set_par) {
  tmp_par = set_par

  if (is.data.frame(set_par)) {
    if (length(set_par) == 1) {
      tmp_par[1] = as.character(tmp_par[[1]])
    } else {
      tmp_par[,] <- sapply(tmp_par[,,drop=FALSE], as.character)
    }
  } else {
    tmp_par = as.character(tmp_par)
  }

  return(reticulate::r_to_py(tmp_par))
}

#' ixmp core
#'
#' This page provides documentation for the ixmp-R-reticulate implementation.
#' The package is sourcing the ixmp-core Python package, translating it with the R 'reticulate' package.
#'
#' Main features:
#'
#'  - a platform core linked to a database instance,
#'
#'  - integration with the |MESSAGEix| Integrated Assessment model
#'    and other numerical models
#'
#'  - for full documentation of the Python functions, use py_help(<package>$<class>)
#' @name rixmp
NULL

#' @import reticulate
NULL

.onAttach <- function(libname, pkgname) {
  packageStartupMessage(
    sprintf(paste0("Loaded rixmp v%s. See ?rixmp for help, ",
                   "citation(\"rixmp\") for use in publication.\n"),
            utils::packageDescription(pkgname)$Version))
}

ixmp <- NULL

.onLoad <- function(libname, pkgname) {
  # Force reticulate to pick up on e.g. RETICULATE_PYTHON environment variable
  reticulate::py_config()

  # If $IXMP_DATA and $XDG_DATA_HOME are not set, ixmp._config.Config uses
  # $HOME/.local/ixmp for configuration and local databases. On Windows, $HOME
  # is C:\Users\[Username]\Documents. Here, XDG_DATA_HOME is set for the
  # reticulate Python process that imports ixmp, so that these files are
  # placed in C:\Users\[Username]\.local\share

  # If the user has aleady set $IXMP_DATA or $XDG_DATA_HOME, do nothing
  vars_set = any(nchar(Sys.getenv(c('IXMP_DATA', 'XDG_DATA_HOME'))))
  if ( .Platform$OS.type == 'windows' & ! vars_set ) {
    # Split $HOME to components
    home <- strsplit(gsub('\\\\', '/', Sys.getenv('HOME')),
                     .Platform$file.sep)[[1]]

    # Filter out 'Documents' and add '.local' and 'share'
    parts <- c(Filter(function (s) s != 'Documents', home), '.local', 'share')

    # Set $XDG_DATA_HOME within the reticulate Python process
    # NB R's Sys.setenv() does not work here if reticulate has already started
    #    Python
    reticulate::py_run_string(paste0(
      "import os; os.environ['XDG_DATA_HOME'] = '",
      do.call('file.path', as.list(parts)), "'"))
  }

  # Set 'ixmp' in the global namespace
  ixmp <<- reticulate::import('ixmp', delay_load = TRUE)
}

- Daniel Huppmann,
  [@danielhuppmann](https://github.com/danielhuppmann),
  [iiasa](http://www.iiasa.ac.at/staff/huppmann)
- Matthew Gidden,
  [@gidden](https://github.com/gidden),
  [iiasa](http://www.iiasa.ac.at/staff/staff.php?type=auto&visibility=visible&search=true&login=gidden),
  [web](http://mattgidden.com)
- Volker Krey,
  [@volker-krey](https://github.com/volker-krey),
  [iiasa](http://www.iiasa.ac.at/staff/staff.php?type=auto&visibility=visible&search=true&login=krey)
- Oliver Fricko, [@OFR-IIASA](https://github.com/OFR-IIASA)
- Peter Kolp,
  [@peterkolp](https://github.com/peterkolp/),
  [iiasa](http://www.iiasa.ac.at/staff/staff.php?type=auto&visibility=visible&search=true&login=kolp)
- Paul Natsuo Kishimoto,
  [@khaeru](https://github.com/khaeru)
  [web](https://paul.kishimoto.name)
- Nikolay Kushin,
  [@zikolach](https://github.com/zikolach)
  [iiasa](http://www.iiasa.ac.at/staff/staff.php?type=auto&visibility=visible&search=true&login=kushin)
- Michael Pimmer,
  [@fonfon](https://github.com/fonfon),
  [iiasa](http://www.iiasa.ac.at/staff/staff.php?type=auto&visibility=visible&search=true&login=pimmer)
- Adriano Vinca,
  [@adrivinca](https://github.com/adrivinca),
  [iiasa](http://www.iiasa.ac.at/staff/staff.php?type=auto&visibility=visible&search=true&login=vinca)

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/init_rixmp.R
\name{rixmp}
\alias{rixmp}
\title{ixmp core}
\description{
This page provides documentation for the ixmp-R-reticulate implementation.
The package is sourcing the ixmp-core Python package, translating it with the R 'reticulate' package.
}
\details{
Main features:

 - a platform core linked to a database instance,

 - integration with the |MESSAGEix| Integrated Assessment model
   and other numerical models

 - for full documentation of the Python functions, use py_help(<package>$<class>)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/adapt_to_ret.R
\name{adapt_to_ret}
\alias{adapt_to_ret}
\title{Auxiliary function for conversion from R data.frame to Python}
\usage{
adapt_to_ret(set_par)
}
\arguments{
\item{set_par}{Dataframe corresponding to a set or a parameter to be loaded
in ixmp}
}
\description{
This function converts an R data.frame to be a valid input to
ixmp$Scenario$add_par() or ixmp$Scenario$add_set().
}
\examples{
if (FALSE) {

a.df <- data.frame(i = c("a", "b"), value = c(350 , 600), unit = "cases")
scen$add_par("a", adapt_to_ret(a.df))

}
}
